'  9-bit PCM Player, plays stereo PCM (up to 16-bit) from a circular buffer
'  Copyright 2009 David Sloan
'  See end of file for terms of use.

VAR                
  long  smppars[6]   
  long  SampleVarL
  long  SampleVarR
  byte  running
  byte  cog

Pub start(pLeft, pRight, pBuffer, BufferLen, pBufferPos, samplePeriod)

  smppars[0] := pLeft
  smppars[1] := pRight
  smppars[2] := pBuffer
  smppars[3] := BufferLen
  smppars[4] := pBufferPos
  smppars[5] := samplePeriod
  if running <> 1                    
    cog := cognew(@smp, @smppars)
    running := 1 

pub stop
  if running == 1
    cogstop(cog)
    running := 0
    

DAT
org 0
              'retrieve parameters
smp           mov       tmp, par
              rdlong    pL, tmp
              add       tmp, #4
              rdlong    pR, tmp
              add       tmp, #4
              rdlong    pbuf, tmp
              add       tmp, #4
              rdlong    buflen, tmp
              add       tmp, #4
              rdlong    pbufPos, tmp
              add       tmp, #4
              rdlong    sPeriod, tmp
              wrlong    Zero, pbufpos
              shl       buflen, #2

              mov       bufpos, #0
              
              mov       sTime, cnt
              add       sTime, sPeriod
              
              'main loop             
sloop         mov       tmp, pbuf
              add       tmp, BufPos
              rdlong    sValL, tmp  
              mov       sValR, SValL
              shr       sValR, #16          
              waitcnt   sTime, sPeriod         
              wrword    sValR, pR 
              wrword    sValL, pL
              add       BufPos, #4
              wrlong    BufPos, PBufPos
              cmp       BufPos, buflen          wc, wz
        if_ae mov       bufpos, #0  
              jmp       #sLoop
      
Zero          long 0
WordMask      long $0000_ffff
invWordMask   long $ffff_0000
HalfWord      long $8000

pL            res 1
pR            res 1
pbuf          res 1
bufLen        res 1
pBufPos       res 1
bufpos        res 1
sPeriod       res 1
sTime         res 1
sValL         res 1
sValR         res 1
tmp           res 1


{{
                            TERMS OF USE: MIT License

 Permission is hereby granted, free of charge, to any person obtaining a copy
 of this software and associated documentation files (the "Software"), to deal
 in the Software without restriction, including without limitation the rights
 to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 copies of the Software, and to permit persons to whom the Software is
 furnished to do so, subject to the following conditions:

 The above copyright notice and this permission notice shall be included in
 all copies or substantial portions of the Software.

 THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,ARISING FROM,
 OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
 THE SOFTWARE.
}}   